﻿using System.Collections.Generic;
using System.Data.Entity.Core.Metadata.Edm;
using System.Diagnostics;
using VfpEntityFrameworkProvider.Visitors;

namespace VfpEntityFrameworkProvider.DbExpressions {
    public class DbInExpression : DbExpression {
        public DbExpression Item { get; set; }
        public IList<DbExpression> List { get; private set; }

        internal DbInExpression(TypeUsage resultType, DbExpression item, DbExpressionList list)
            : base(DbExpressionKind.In, resultType) {
            Item = item;
            List = list;
        }

        [DebuggerStepThrough]
        public override TResultType Accept<TResultType>(DbExpressionVisitorBase<TResultType> visitor) {
            return ArgumentUtility.CheckNotNull("visitor", visitor).Visit(this);
        }
    }
}