using System.Data.Entity.Core.Metadata.Edm;
using System.Diagnostics;
using VfpEntityFrameworkProvider.Visitors;

namespace VfpEntityFrameworkProvider.DbExpressions {
    public class VfpLikeCExpression : DbExpression {
        public DbExpression Argument { get; private set; }
        public DbExpression Pattern { get; private set; }

        internal VfpLikeCExpression(TypeUsage resultType, DbExpression argument, DbExpression pattern)
            : base(DbExpressionKind.LikeC, resultType) {
            Argument = argument;
            Pattern = pattern;
        }

        [DebuggerStepThrough]
        public override TResultType Accept<TResultType>(DbExpressionVisitorBase<TResultType> visitor) {
            return ArgumentUtility.CheckNotNull("visitor", visitor).Visit(this);
        }
    }
}