/*
 * VFP Entity Framework Provider
 * http://vfpefprovider.codeplex.com/
 * http://www.randomdevnotes.com/tag/vfp-ef-provider/
 * 
 * Written by Tom Brothers (TomBrothers@Outlook.com)
 * 
 * Released to the public domain, use at your own risk!
 */
/*
 * VFP Entity Framework Provider
 * http://vfpefprovider.codeplex.com/
 * http://www.randomdevnotes.com/tag/vfp-ef-provider/
 * 
 * Written by Tom Brothers (trbrothers@hotmail.com)
 * 
 * Released to the public domain, use at your own risk!
 */
using System.Collections.Generic;
using VfpEntityFrameworkProvider.DbExpressions;

namespace VfpEntityFrameworkProvider.Visitors.Gatherers {
    internal class DbOrLikeGatherer : DbExpressionVisitor {
        private List<DbLikeExpression> _list = new List<DbLikeExpression>();
        private bool _invalid;

        public static List<DbLikeExpression> Gather(DbOrExpression expression) {
            var visitor = new DbOrLikeGatherer();

            visitor.Visit(expression);

            if (visitor._invalid) {
                return new List<DbLikeExpression>();
            }

            return visitor._list;
        }

        public override DbExpression Visit(DbAndExpression expression) {
            this._invalid = true;

            return base.Visit(expression);
        }

        public override DbExpression Visit(DbLikeExpression expression) {
            this._list.Add(expression);

            return base.Visit(expression);
        }
    }
}